/*
  Author:  James Tam
  Version: March 24, 2003

  The driver class for the Dungeon Master game.

 */
class DungeonMaster
{
    public static void main (String [] argv)
    {
	BlueDragon electro = new BlueDragon ();
	Monster aMonster;

	// Fly: Method in class Dragon that's not in class Monster
	// AbsorbElectricity: Method in class BlueDragon that's not in class Dragon
	electro.fly();
	electro.absorbElectricity();

	// Okay: Assigning from subclass to superclass (more abilities)
       	aMonster = electro;

	// Okay: Class BlueDragon has more attributes and methods than class Monster
	aMonster = (Monster) electro;

	// Compile time error: Because class Monster doesn't have these methods the
	// compiler can't bind these methods to the type refered to by aMonster at
	// compile time.
	// aMonster.fly();
	// aMonster.absorbElectricity();
	
	aMonster = new Monster ();
	// Won't work, assigning from super class to sub class (fewer abilities)
	// electro = aMonster;

	// Not okay: Class BlueDragon has more attributes and methods than class Monster
	// Runtime error: ClassCastException
       	//electro = (BlueDragon) aMonster;
	electro.fly();
	electro.absorbElectricity();

	if (electro instanceof Monster)
	{
	    System.out.println("electro is an instance of a Monster");
	    aMonster = (Monster) electro;
	}
	  
	aMonster = electro;
	if (aMonster instanceof BlueDragon)
	{
	    System.out.println("AMonster is actually an instance of a BlueDragon");
	    ((BlueDragon) aMonster).fly();
	    ((BlueDragon) aMonster).absorbElectricity();

	}
	electro.fly();
	electro.absorbElectricity();

    }
}
